#ifndef __CTYPE
#define __CTYPE

extern int isalnum(int);
extern int isalpha(int);
extern int iscntrl(int);
extern int isdigit(int);
extern int isgraph(int);
extern int islower(int);
extern int isprint(int);
extern int ispunct(int);
extern int isspace(int);
extern int isupper(int);
extern int isxdigit(int);
extern int tolower(int);
extern int toupper(int);

#define	__U	01    
#define	__L	02    
#define	__D	04    
#define	__S	010   
#define	__P	020   
#define	__C	040   
#define	__B	0100  
#define	__X	0200  

extern unsigned char __ctype[];
#define	isalpha(c)	((__ctype + 1)[c] & (__U | __L))
#define	isupper(c)	((__ctype + 1)[c] & __U)
#define	islower(c)	((__ctype + 1)[c] & __L)
#define	isdigit(c)	((__ctype + 1)[c] & __D)
#define	isxdigit(c)	((__ctype + 1)[c] & (__D | __X))
#define	isalnum(c)	((__ctype + 1)[c] & (__U | __L | __D))
#define	isspace(c)	((__ctype + 1)[c] & __S)
#define	ispunct(c)	((__ctype + 1)[c] & __P)
#define	isprint(c)	((__ctype + 1)[c] & (__P | __U | __L | __D | __B))
#define	isgraph(c)	((__ctype + 1)[c] & (__P | __U | __L | __D))
#define	iscntrl(c)	((__ctype + 1)[c] & __C)

#endif /* __CTYPE */
